# coding: utf-8

"""
    Rakam API Documentation

    An analytics platform API that lets you create your own analytics services.

    OpenAPI spec version: 0.5
    Contact: contact@rakam.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
"""

from __future__ import absolute_import

# import models into sdk package
from .models.analyze_request import AnalyzeRequest
from .models.bulk_event_remote import BulkEventRemote
from .models.check_lock_key import CheckLockKey
from .models.collection import Collection
from .models.collection_definition import CollectionDefinition
from .models.collection_event import CollectionEvent
from .models.commit_bulk_events import CommitBulkEvents
from .models.commit_request import CommitRequest
from .models.condition import Condition
from .models.config_item import ConfigItem
from .models.continuous_query import ContinuousQuery
from .models.continuous_query_delete_query import ContinuousQueryDeleteQuery
from .models.continuous_query_get_query import ContinuousQueryGetQuery
from .models.continuous_query_get_schema_of_query import ContinuousQueryGetSchemaOfQuery
from .models.continuous_query_test_query import ContinuousQueryTestQuery
from .models.create_precomputed_table import CreatePrecomputedTable
from .models.create_project import CreateProject
from .models.email_action_config import EmailActionConfig
from .models.error_message import ErrorMessage
from .models.event import Event
from .models.event_context import EventContext
from .models.event_explorer_get_event_statistics import EventExplorerGetEventStatistics
from .models.event_filter import EventFilter
from .models.event_filter_aggregation import EventFilterAggregation
from .models.event_list import EventList
from .models.execute import Execute
from .models.explain import Explain
from .models.export_query import ExportQuery
from .models.funnel_query import FunnelQuery
from .models.funnel_step import FunnelStep
from .models.funnel_window import FunnelWindow
from .models.group_by import GroupBy
from .models.library import Library
from .models.mapping_plugin import MappingPlugin
from .models.materialized_view import MaterializedView
from .models.materialized_view_delete_view import MaterializedViewDeleteView
from .models.materialized_view_get_schema_of_view import MaterializedViewGetSchemaOfView
from .models.materialized_view_get_view import MaterializedViewGetView
from .models.materialized_view_schema import MaterializedViewSchema
from .models.measure import Measure
from .models.metadata_response import MetadataResponse
from .models.module_descriptor import ModuleDescriptor
from .models.olap_table import OLAPTable
from .models.ordering import Ordering
from .models.precalculated_table import PrecalculatedTable
from .models.project_add_custom_fields_to_schema import ProjectAddCustomFieldsToSchema
from .models.project_add_fields_to_schema import ProjectAddFieldsToSchema
from .models.project_api_keys import ProjectApiKeys
from .models.project_check_api_keys import ProjectCheckApiKeys
from .models.project_get_stats import ProjectGetStats
from .models.project_schema import ProjectSchema
from .models.query_error import QueryError
from .models.query_metadata import QueryMetadata
from .models.query_result import QueryResult
from .models.real_time_query_result import RealTimeQueryResult
from .models.real_time_report import RealTimeReport
from .models.realtime_delete_table import RealtimeDeleteTable
from .models.realtime_query_table import RealtimeQueryTable
from .models.recipe import Recipe
from .models.reference import Reference
from .models.response_query import ResponseQuery
from .models.retention_action import RetentionAction
from .models.retention_query import RetentionQuery
from .models.schema_field import SchemaField
from .models.schema_field_info import SchemaFieldInfo
from .models.sorting import Sorting
from .models.stats import Stats
from .models.success_message import SuccessMessage
from .models.timeframe import Timeframe
from .models.user import User
from .models.user_context import UserContext
from .models.user_create_segment import UserCreateSegment
from .models.user_create_users import UserCreateUsers
from .models.user_email_action_batch import UserEmailActionBatch
from .models.user_email_action_send import UserEmailActionSend
from .models.user_get_events import UserGetEvents
from .models.user_get_user import UserGetUser
from .models.user_increment_property import UserIncrementProperty
from .models.user_search_users import UserSearchUsers
from .models.user_unset_property import UserUnsetProperty

# import apis into sdk package
from .apis.admin_api import AdminApi
from .apis.collect_api import CollectApi
from .apis.continuousquery_api import ContinuousqueryApi
from .apis.eventexplorer_api import EventexplorerApi
from .apis.funnel_api import FunnelApi
from .apis.materializedview_api import MaterializedviewApi
from .apis.query_api import QueryApi
from .apis.realtime_api import RealtimeApi
from .apis.recipe_api import RecipeApi
from .apis.retention_api import RetentionApi
from .apis.user_api import UserApi
from .apis.useraction_api import UseractionApi

# import ApiClient
from .api_client import ApiClient

from .configuration import Configuration

configuration = Configuration()
