# coding: utf-8

"""
    Rakam API Documentation

    An analytics platform API that lets you create your own analytics services.

    OpenAPI spec version: 0.5
    Contact: contact@rakam.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
"""

from __future__ import absolute_import

import sys
import os
import re

# python 2 and python 3 compatibility library
from six import iteritems

from ..configuration import Configuration
from ..api_client import ApiClient


class EventexplorerApi(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        config = Configuration()
        if api_client:
            self.api_client = api_client
        else:
            if not config.api_client:
                config.api_client = ApiClient()
            self.api_client = config.api_client

    def analyze_events(self, **kwargs):
        """
        Perform simple query on event data
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.analyze_events(analyze_request=analyze_request_value, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param AnalyzeRequest analyze_request:  (required)
        :return: QueryResult
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.analyze_events_with_http_info(**kwargs)
        else:
            (data) = self.analyze_events_with_http_info(**kwargs)
            return data

    def analyze_events_with_http_info(self, **kwargs):
        """
        Perform simple query on event data
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.analyze_events_with_http_info(analyze_request=analyze_request_value, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param AnalyzeRequest analyze_request:  (required)
        :return: QueryResult
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['analyze_request']
        all_params.append('callback')
        all_params.append('_return_http_data_only')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method analyze_events" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'analyze_request' is set
        if ('analyze_request' not in params) or (params['analyze_request'] is None):
            raise ValueError("Missing the required parameter `analyze_request` when calling `analyze_events`")

        resource_path = '/event-explorer/analyze'.replace('{format}', 'json')
        path_params = {}

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'analyze_request' in params:
            body_params = params['analyze_request']

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = ['read_key']

        return self.api_client.call_api(resource_path, 'POST',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='QueryResult',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'),
                                            _return_http_data_only=params.get('_return_http_data_only'))

    def create_precomputed_table(self, **kwargs):
        """
        Create Pre-computed table
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.create_precomputed_table(create_precomputed_table=create_precomputed_table_value, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param CreatePrecomputedTable create_precomputed_table:  (required)
        :return: PrecalculatedTable
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.create_precomputed_table_with_http_info(**kwargs)
        else:
            (data) = self.create_precomputed_table_with_http_info(**kwargs)
            return data

    def create_precomputed_table_with_http_info(self, **kwargs):
        """
        Create Pre-computed table
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.create_precomputed_table_with_http_info(create_precomputed_table=create_precomputed_table_value, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param CreatePrecomputedTable create_precomputed_table:  (required)
        :return: PrecalculatedTable
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['create_precomputed_table']
        all_params.append('callback')
        all_params.append('_return_http_data_only')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_precomputed_table" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'create_precomputed_table' is set
        if ('create_precomputed_table' not in params) or (params['create_precomputed_table'] is None):
            raise ValueError("Missing the required parameter `create_precomputed_table` when calling `create_precomputed_table`")

        resource_path = '/event-explorer/pre_calculate'.replace('{format}', 'json')
        path_params = {}

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'create_precomputed_table' in params:
            body_params = params['create_precomputed_table']

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = ['master_key']

        return self.api_client.call_api(resource_path, 'POST',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='PrecalculatedTable',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'),
                                            _return_http_data_only=params.get('_return_http_data_only'))

    def get_event_statistics(self, **kwargs):
        """
        Event statistics
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.get_event_statistics(event_explorer_get_event_statistics=event_explorer_get_event_statistics_value, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param EventExplorerGetEventStatistics event_explorer_get_event_statistics:  (required)
        :return: QueryResult
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.get_event_statistics_with_http_info(**kwargs)
        else:
            (data) = self.get_event_statistics_with_http_info(**kwargs)
            return data

    def get_event_statistics_with_http_info(self, **kwargs):
        """
        Event statistics
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.get_event_statistics_with_http_info(event_explorer_get_event_statistics=event_explorer_get_event_statistics_value, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param EventExplorerGetEventStatistics event_explorer_get_event_statistics:  (required)
        :return: QueryResult
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['event_explorer_get_event_statistics']
        all_params.append('callback')
        all_params.append('_return_http_data_only')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_event_statistics" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'event_explorer_get_event_statistics' is set
        if ('event_explorer_get_event_statistics' not in params) or (params['event_explorer_get_event_statistics'] is None):
            raise ValueError("Missing the required parameter `event_explorer_get_event_statistics` when calling `get_event_statistics`")

        resource_path = '/event-explorer/statistics'.replace('{format}', 'json')
        path_params = {}

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'event_explorer_get_event_statistics' in params:
            body_params = params['event_explorer_get_event_statistics']

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = ['read_key']

        return self.api_client.call_api(resource_path, 'POST',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='QueryResult',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'),
                                            _return_http_data_only=params.get('_return_http_data_only'))

    def get_extra_dimensions(self, **kwargs):
        """
        Event statistics
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.get_extra_dimensions(callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :return: dict(str, list[str])
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.get_extra_dimensions_with_http_info(**kwargs)
        else:
            (data) = self.get_extra_dimensions_with_http_info(**kwargs)
            return data

    def get_extra_dimensions_with_http_info(self, **kwargs):
        """
        Event statistics
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.get_extra_dimensions_with_http_info(callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :return: dict(str, list[str])
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = []
        all_params.append('callback')
        all_params.append('_return_http_data_only')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_extra_dimensions" % key
                )
            params[key] = val
        del params['kwargs']

        resource_path = '/event-explorer/extra_dimensions'.replace('{format}', 'json')
        path_params = {}

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = ['read_key']

        return self.api_client.call_api(resource_path, 'GET',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='dict(str, list[str])',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'),
                                            _return_http_data_only=params.get('_return_http_data_only'))
