# coding: utf-8

"""
    Rakam API Documentation

    An analytics platform API that lets you create your own analytics services.

    OpenAPI spec version: 0.5
    Contact: contact@rakam.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
"""

from __future__ import absolute_import

import sys
import os
import re

# python 2 and python 3 compatibility library
from six import iteritems

from ..configuration import Configuration
from ..api_client import ApiClient


class MaterializedviewApi(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        config = Configuration()
        if api_client:
            self.api_client = api_client
        else:
            if not config.api_client:
                config.api_client = ApiClient()
            self.api_client = config.api_client

    def create_view(self, **kwargs):
        """
        Create view
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.create_view(materialized_view=materialized_view_value, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param MaterializedView materialized_view:  (required)
        :return: SuccessMessage
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.create_view_with_http_info(**kwargs)
        else:
            (data) = self.create_view_with_http_info(**kwargs)
            return data

    def create_view_with_http_info(self, **kwargs):
        """
        Create view
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.create_view_with_http_info(materialized_view=materialized_view_value, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param MaterializedView materialized_view:  (required)
        :return: SuccessMessage
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['materialized_view']
        all_params.append('callback')
        all_params.append('_return_http_data_only')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_view" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'materialized_view' is set
        if ('materialized_view' not in params) or (params['materialized_view'] is None):
            raise ValueError("Missing the required parameter `materialized_view` when calling `create_view`")

        resource_path = '/materialized-view/create'.replace('{format}', 'json')
        path_params = {}

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'materialized_view' in params:
            body_params = params['materialized_view']

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = ['master_key']

        return self.api_client.call_api(resource_path, 'POST',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='SuccessMessage',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'),
                                            _return_http_data_only=params.get('_return_http_data_only'))

    def delete_view(self, **kwargs):
        """
        Delete materialized view
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.delete_view(materialized_view_delete_view=materialized_view_delete_view_value, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param MaterializedViewDeleteView materialized_view_delete_view:  (required)
        :return: SuccessMessage
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.delete_view_with_http_info(**kwargs)
        else:
            (data) = self.delete_view_with_http_info(**kwargs)
            return data

    def delete_view_with_http_info(self, **kwargs):
        """
        Delete materialized view
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.delete_view_with_http_info(materialized_view_delete_view=materialized_view_delete_view_value, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param MaterializedViewDeleteView materialized_view_delete_view:  (required)
        :return: SuccessMessage
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['materialized_view_delete_view']
        all_params.append('callback')
        all_params.append('_return_http_data_only')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_view" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'materialized_view_delete_view' is set
        if ('materialized_view_delete_view' not in params) or (params['materialized_view_delete_view'] is None):
            raise ValueError("Missing the required parameter `materialized_view_delete_view` when calling `delete_view`")

        resource_path = '/materialized-view/delete'.replace('{format}', 'json')
        path_params = {}

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'materialized_view_delete_view' in params:
            body_params = params['materialized_view_delete_view']

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = ['master_key']

        return self.api_client.call_api(resource_path, 'POST',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='SuccessMessage',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'),
                                            _return_http_data_only=params.get('_return_http_data_only'))

    def get_schema_of_view(self, **kwargs):
        """
        Get schemas
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.get_schema_of_view(materialized_view_get_schema_of_view=materialized_view_get_schema_of_view_value, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param MaterializedViewGetSchemaOfView materialized_view_get_schema_of_view:  (required)
        :return: list[MaterializedViewSchema]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.get_schema_of_view_with_http_info(**kwargs)
        else:
            (data) = self.get_schema_of_view_with_http_info(**kwargs)
            return data

    def get_schema_of_view_with_http_info(self, **kwargs):
        """
        Get schemas
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.get_schema_of_view_with_http_info(materialized_view_get_schema_of_view=materialized_view_get_schema_of_view_value, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param MaterializedViewGetSchemaOfView materialized_view_get_schema_of_view:  (required)
        :return: list[MaterializedViewSchema]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['materialized_view_get_schema_of_view']
        all_params.append('callback')
        all_params.append('_return_http_data_only')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_schema_of_view" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'materialized_view_get_schema_of_view' is set
        if ('materialized_view_get_schema_of_view' not in params) or (params['materialized_view_get_schema_of_view'] is None):
            raise ValueError("Missing the required parameter `materialized_view_get_schema_of_view` when calling `get_schema_of_view`")

        resource_path = '/materialized-view/schema'.replace('{format}', 'json')
        path_params = {}

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'materialized_view_get_schema_of_view' in params:
            body_params = params['materialized_view_get_schema_of_view']

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = ['read_key']

        return self.api_client.call_api(resource_path, 'POST',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='list[MaterializedViewSchema]',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'),
                                            _return_http_data_only=params.get('_return_http_data_only'))

    def get_view(self, **kwargs):
        """
        Get view
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.get_view(materialized_view_get_view=materialized_view_get_view_value, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param MaterializedViewGetView materialized_view_get_view:  (required)
        :return: MaterializedView
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.get_view_with_http_info(**kwargs)
        else:
            (data) = self.get_view_with_http_info(**kwargs)
            return data

    def get_view_with_http_info(self, **kwargs):
        """
        Get view
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.get_view_with_http_info(materialized_view_get_view=materialized_view_get_view_value, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param MaterializedViewGetView materialized_view_get_view:  (required)
        :return: MaterializedView
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['materialized_view_get_view']
        all_params.append('callback')
        all_params.append('_return_http_data_only')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_view" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'materialized_view_get_view' is set
        if ('materialized_view_get_view' not in params) or (params['materialized_view_get_view'] is None):
            raise ValueError("Missing the required parameter `materialized_view_get_view` when calling `get_view`")

        resource_path = '/materialized-view/get'.replace('{format}', 'json')
        path_params = {}

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'materialized_view_get_view' in params:
            body_params = params['materialized_view_get_view']

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = ['read_key']

        return self.api_client.call_api(resource_path, 'POST',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='MaterializedView',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'),
                                            _return_http_data_only=params.get('_return_http_data_only'))

    def list_views(self, **kwargs):
        """
        List views
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.list_views(callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :return: list[MaterializedView]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.list_views_with_http_info(**kwargs)
        else:
            (data) = self.list_views_with_http_info(**kwargs)
            return data

    def list_views_with_http_info(self, **kwargs):
        """
        List views
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.list_views_with_http_info(callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :return: list[MaterializedView]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = []
        all_params.append('callback')
        all_params.append('_return_http_data_only')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method list_views" % key
                )
            params[key] = val
        del params['kwargs']

        resource_path = '/materialized-view/list'.replace('{format}', 'json')
        path_params = {}

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = ['read_key']

        return self.api_client.call_api(resource_path, 'POST',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='list[MaterializedView]',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'),
                                            _return_http_data_only=params.get('_return_http_data_only'))
