# coding: utf-8

"""
    Rakam API Documentation

    An analytics platform API that lets you create your own analytics services.

    OpenAPI spec version: 0.5
    Contact: contact@rakam.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
"""

from pprint import pformat
from six import iteritems
import re


class AnalyzeRequest(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, measure=None, grouping=None, segment=None, filter_expression=None, start_date=None, end_date=None, collections=None):
        """
        AnalyzeRequest - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'measure': 'Measure',
            'grouping': 'Reference',
            'segment': 'Reference',
            'filter_expression': 'str',
            'start_date': 'date',
            'end_date': 'date',
            'collections': 'list[str]'
        }

        self.attribute_map = {
            'measure': 'measure',
            'grouping': 'grouping',
            'segment': 'segment',
            'filter_expression': 'filterExpression',
            'start_date': 'startDate',
            'end_date': 'endDate',
            'collections': 'collections'
        }

        self._measure = measure
        self._grouping = grouping
        self._segment = segment
        self._filter_expression = filter_expression
        self._start_date = start_date
        self._end_date = end_date
        self._collections = collections

    @property
    def measure(self):
        """
        Gets the measure of this AnalyzeRequest.


        :return: The measure of this AnalyzeRequest.
        :rtype: Measure
        """
        return self._measure

    @measure.setter
    def measure(self, measure):
        """
        Sets the measure of this AnalyzeRequest.


        :param measure: The measure of this AnalyzeRequest.
        :type: Measure
        """

        self._measure = measure

    @property
    def grouping(self):
        """
        Gets the grouping of this AnalyzeRequest.


        :return: The grouping of this AnalyzeRequest.
        :rtype: Reference
        """
        return self._grouping

    @grouping.setter
    def grouping(self, grouping):
        """
        Sets the grouping of this AnalyzeRequest.


        :param grouping: The grouping of this AnalyzeRequest.
        :type: Reference
        """

        self._grouping = grouping

    @property
    def segment(self):
        """
        Gets the segment of this AnalyzeRequest.


        :return: The segment of this AnalyzeRequest.
        :rtype: Reference
        """
        return self._segment

    @segment.setter
    def segment(self, segment):
        """
        Sets the segment of this AnalyzeRequest.


        :param segment: The segment of this AnalyzeRequest.
        :type: Reference
        """

        self._segment = segment

    @property
    def filter_expression(self):
        """
        Gets the filter_expression of this AnalyzeRequest.


        :return: The filter_expression of this AnalyzeRequest.
        :rtype: str
        """
        return self._filter_expression

    @filter_expression.setter
    def filter_expression(self, filter_expression):
        """
        Sets the filter_expression of this AnalyzeRequest.


        :param filter_expression: The filter_expression of this AnalyzeRequest.
        :type: str
        """

        self._filter_expression = filter_expression

    @property
    def start_date(self):
        """
        Gets the start_date of this AnalyzeRequest.


        :return: The start_date of this AnalyzeRequest.
        :rtype: date
        """
        return self._start_date

    @start_date.setter
    def start_date(self, start_date):
        """
        Sets the start_date of this AnalyzeRequest.


        :param start_date: The start_date of this AnalyzeRequest.
        :type: date
        """

        self._start_date = start_date

    @property
    def end_date(self):
        """
        Gets the end_date of this AnalyzeRequest.


        :return: The end_date of this AnalyzeRequest.
        :rtype: date
        """
        return self._end_date

    @end_date.setter
    def end_date(self, end_date):
        """
        Sets the end_date of this AnalyzeRequest.


        :param end_date: The end_date of this AnalyzeRequest.
        :type: date
        """

        self._end_date = end_date

    @property
    def collections(self):
        """
        Gets the collections of this AnalyzeRequest.


        :return: The collections of this AnalyzeRequest.
        :rtype: list[str]
        """
        return self._collections

    @collections.setter
    def collections(self, collections):
        """
        Sets the collections of this AnalyzeRequest.


        :param collections: The collections of this AnalyzeRequest.
        :type: list[str]
        """

        self._collections = collections

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
