# coding: utf-8

"""
    Rakam API Documentation

    An analytics platform API that lets you create your own analytics services.

    OpenAPI spec version: 0.5
    Contact: contact@rakam.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
"""

from pprint import pformat
from six import iteritems
import re


class ContinuousQuery(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, name=None, query=None, options=None, table_name=None, partition_keys=None):
        """
        ContinuousQuery - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'name': 'str',
            'query': 'str',
            'options': 'dict(str, object)',
            'table_name': 'str',
            'partition_keys': 'list[str]'
        }

        self.attribute_map = {
            'name': 'name',
            'query': 'query',
            'options': 'options',
            'table_name': 'tableName',
            'partition_keys': 'partitionKeys'
        }

        self._name = name
        self._query = query
        self._options = options
        self._table_name = table_name
        self._partition_keys = partition_keys

    @property
    def name(self):
        """
        Gets the name of this ContinuousQuery.


        :return: The name of this ContinuousQuery.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this ContinuousQuery.


        :param name: The name of this ContinuousQuery.
        :type: str
        """

        self._name = name

    @property
    def query(self):
        """
        Gets the query of this ContinuousQuery.


        :return: The query of this ContinuousQuery.
        :rtype: str
        """
        return self._query

    @query.setter
    def query(self, query):
        """
        Sets the query of this ContinuousQuery.


        :param query: The query of this ContinuousQuery.
        :type: str
        """

        self._query = query

    @property
    def options(self):
        """
        Gets the options of this ContinuousQuery.


        :return: The options of this ContinuousQuery.
        :rtype: dict(str, object)
        """
        return self._options

    @options.setter
    def options(self, options):
        """
        Sets the options of this ContinuousQuery.


        :param options: The options of this ContinuousQuery.
        :type: dict(str, object)
        """

        self._options = options

    @property
    def table_name(self):
        """
        Gets the table_name of this ContinuousQuery.


        :return: The table_name of this ContinuousQuery.
        :rtype: str
        """
        return self._table_name

    @table_name.setter
    def table_name(self, table_name):
        """
        Sets the table_name of this ContinuousQuery.


        :param table_name: The table_name of this ContinuousQuery.
        :type: str
        """

        self._table_name = table_name

    @property
    def partition_keys(self):
        """
        Gets the partition_keys of this ContinuousQuery.


        :return: The partition_keys of this ContinuousQuery.
        :rtype: list[str]
        """
        return self._partition_keys

    @partition_keys.setter
    def partition_keys(self, partition_keys):
        """
        Sets the partition_keys of this ContinuousQuery.


        :param partition_keys: The partition_keys of this ContinuousQuery.
        :type: list[str]
        """

        self._partition_keys = partition_keys

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
