# coding: utf-8

"""
    Rakam API Documentation

    An analytics platform API that lets you create your own analytics services.

    OpenAPI spec version: 0.5
    Contact: contact@rakam.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
"""

from pprint import pformat
from six import iteritems
import re


class EventContext(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, api_key=None, library=None, api_version=None, upload_time=None, checksum=None, plugins=None):
        """
        EventContext - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'api_key': 'str',
            'library': 'Library',
            'api_version': 'str',
            'upload_time': 'int',
            'checksum': 'str',
            'plugins': 'list[MappingPlugin]'
        }

        self.attribute_map = {
            'api_key': 'api_key',
            'library': 'library',
            'api_version': 'api_version',
            'upload_time': 'upload_time',
            'checksum': 'checksum',
            'plugins': 'plugins'
        }

        self._api_key = api_key
        self._library = library
        self._api_version = api_version
        self._upload_time = upload_time
        self._checksum = checksum
        self._plugins = plugins

    @property
    def api_key(self):
        """
        Gets the api_key of this EventContext.


        :return: The api_key of this EventContext.
        :rtype: str
        """
        return self._api_key

    @api_key.setter
    def api_key(self, api_key):
        """
        Sets the api_key of this EventContext.


        :param api_key: The api_key of this EventContext.
        :type: str
        """

        self._api_key = api_key

    @property
    def library(self):
        """
        Gets the library of this EventContext.


        :return: The library of this EventContext.
        :rtype: Library
        """
        return self._library

    @library.setter
    def library(self, library):
        """
        Sets the library of this EventContext.


        :param library: The library of this EventContext.
        :type: Library
        """

        self._library = library

    @property
    def api_version(self):
        """
        Gets the api_version of this EventContext.


        :return: The api_version of this EventContext.
        :rtype: str
        """
        return self._api_version

    @api_version.setter
    def api_version(self, api_version):
        """
        Sets the api_version of this EventContext.


        :param api_version: The api_version of this EventContext.
        :type: str
        """

        self._api_version = api_version

    @property
    def upload_time(self):
        """
        Gets the upload_time of this EventContext.


        :return: The upload_time of this EventContext.
        :rtype: int
        """
        return self._upload_time

    @upload_time.setter
    def upload_time(self, upload_time):
        """
        Sets the upload_time of this EventContext.


        :param upload_time: The upload_time of this EventContext.
        :type: int
        """

        self._upload_time = upload_time

    @property
    def checksum(self):
        """
        Gets the checksum of this EventContext.


        :return: The checksum of this EventContext.
        :rtype: str
        """
        return self._checksum

    @checksum.setter
    def checksum(self, checksum):
        """
        Sets the checksum of this EventContext.


        :param checksum: The checksum of this EventContext.
        :type: str
        """

        self._checksum = checksum

    @property
    def plugins(self):
        """
        Gets the plugins of this EventContext.


        :return: The plugins of this EventContext.
        :rtype: list[MappingPlugin]
        """
        return self._plugins

    @plugins.setter
    def plugins(self, plugins):
        """
        Sets the plugins of this EventContext.


        :param plugins: The plugins of this EventContext.
        :type: list[MappingPlugin]
        """

        self._plugins = plugins

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
