# coding: utf-8

"""
    Rakam API Documentation

    An analytics platform API that lets you create your own analytics services.

    OpenAPI spec version: 0.5
    Contact: contact@rakam.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
"""

from pprint import pformat
from six import iteritems
import re


class EventFilter(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, collection=None, timeframe=None, aggregation=None, filter_expression=None):
        """
        EventFilter - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'collection': 'str',
            'timeframe': 'Timeframe',
            'aggregation': 'EventFilterAggregation',
            'filter_expression': 'str'
        }

        self.attribute_map = {
            'collection': 'collection',
            'timeframe': 'timeframe',
            'aggregation': 'aggregation',
            'filter_expression': 'filterExpression'
        }

        self._collection = collection
        self._timeframe = timeframe
        self._aggregation = aggregation
        self._filter_expression = filter_expression

    @property
    def collection(self):
        """
        Gets the collection of this EventFilter.


        :return: The collection of this EventFilter.
        :rtype: str
        """
        return self._collection

    @collection.setter
    def collection(self, collection):
        """
        Sets the collection of this EventFilter.


        :param collection: The collection of this EventFilter.
        :type: str
        """

        self._collection = collection

    @property
    def timeframe(self):
        """
        Gets the timeframe of this EventFilter.


        :return: The timeframe of this EventFilter.
        :rtype: Timeframe
        """
        return self._timeframe

    @timeframe.setter
    def timeframe(self, timeframe):
        """
        Sets the timeframe of this EventFilter.


        :param timeframe: The timeframe of this EventFilter.
        :type: Timeframe
        """

        self._timeframe = timeframe

    @property
    def aggregation(self):
        """
        Gets the aggregation of this EventFilter.


        :return: The aggregation of this EventFilter.
        :rtype: EventFilterAggregation
        """
        return self._aggregation

    @aggregation.setter
    def aggregation(self, aggregation):
        """
        Sets the aggregation of this EventFilter.


        :param aggregation: The aggregation of this EventFilter.
        :type: EventFilterAggregation
        """

        self._aggregation = aggregation

    @property
    def filter_expression(self):
        """
        Gets the filter_expression of this EventFilter.


        :return: The filter_expression of this EventFilter.
        :rtype: str
        """
        return self._filter_expression

    @filter_expression.setter
    def filter_expression(self, filter_expression):
        """
        Sets the filter_expression of this EventFilter.


        :param filter_expression: The filter_expression of this EventFilter.
        :type: str
        """

        self._filter_expression = filter_expression

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
