# coding: utf-8

"""
    Rakam API Documentation

    An analytics platform API that lets you create your own analytics services.

    OpenAPI spec version: 0.5
    Contact: contact@rakam.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
"""

from pprint import pformat
from six import iteritems
import re


class MaterializedView(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, table_name=None, name=None, query=None, update_interval=None, incremental=False, options=None, last_update=None):
        """
        MaterializedView - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'table_name': 'str',
            'name': 'str',
            'query': 'str',
            'update_interval': 'str',
            'incremental': 'bool',
            'options': 'dict(str, object)',
            'last_update': 'datetime'
        }

        self.attribute_map = {
            'table_name': 'table_name',
            'name': 'name',
            'query': 'query',
            'update_interval': 'update_interval',
            'incremental': 'incremental',
            'options': 'options',
            'last_update': 'last_update'
        }

        self._table_name = table_name
        self._name = name
        self._query = query
        self._update_interval = update_interval
        self._incremental = incremental
        self._options = options
        self._last_update = last_update

    @property
    def table_name(self):
        """
        Gets the table_name of this MaterializedView.


        :return: The table_name of this MaterializedView.
        :rtype: str
        """
        return self._table_name

    @table_name.setter
    def table_name(self, table_name):
        """
        Sets the table_name of this MaterializedView.


        :param table_name: The table_name of this MaterializedView.
        :type: str
        """

        self._table_name = table_name

    @property
    def name(self):
        """
        Gets the name of this MaterializedView.


        :return: The name of this MaterializedView.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this MaterializedView.


        :param name: The name of this MaterializedView.
        :type: str
        """

        self._name = name

    @property
    def query(self):
        """
        Gets the query of this MaterializedView.


        :return: The query of this MaterializedView.
        :rtype: str
        """
        return self._query

    @query.setter
    def query(self, query):
        """
        Sets the query of this MaterializedView.


        :param query: The query of this MaterializedView.
        :type: str
        """

        self._query = query

    @property
    def update_interval(self):
        """
        Gets the update_interval of this MaterializedView.


        :return: The update_interval of this MaterializedView.
        :rtype: str
        """
        return self._update_interval

    @update_interval.setter
    def update_interval(self, update_interval):
        """
        Sets the update_interval of this MaterializedView.


        :param update_interval: The update_interval of this MaterializedView.
        :type: str
        """

        self._update_interval = update_interval

    @property
    def incremental(self):
        """
        Gets the incremental of this MaterializedView.


        :return: The incremental of this MaterializedView.
        :rtype: bool
        """
        return self._incremental

    @incremental.setter
    def incremental(self, incremental):
        """
        Sets the incremental of this MaterializedView.


        :param incremental: The incremental of this MaterializedView.
        :type: bool
        """

        self._incremental = incremental

    @property
    def options(self):
        """
        Gets the options of this MaterializedView.


        :return: The options of this MaterializedView.
        :rtype: dict(str, object)
        """
        return self._options

    @options.setter
    def options(self, options):
        """
        Sets the options of this MaterializedView.


        :param options: The options of this MaterializedView.
        :type: dict(str, object)
        """

        self._options = options

    @property
    def last_update(self):
        """
        Gets the last_update of this MaterializedView.


        :return: The last_update of this MaterializedView.
        :rtype: datetime
        """
        return self._last_update

    @last_update.setter
    def last_update(self, last_update):
        """
        Sets the last_update of this MaterializedView.


        :param last_update: The last_update of this MaterializedView.
        :type: datetime
        """

        self._last_update = last_update

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
