# coding: utf-8

"""
    Rakam API Documentation

    An analytics platform API that lets you create your own analytics services.

    OpenAPI spec version: 0.5
    Contact: contact@rakam.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
"""

from pprint import pformat
from six import iteritems
import re


class Recipe(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, strategy=None, collections=None, materialized_views=None, continuous_queries=None):
        """
        Recipe - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'strategy': 'str',
            'collections': 'dict(str, CollectionDefinition)',
            'materialized_views': 'list[MaterializedView]',
            'continuous_queries': 'list[ContinuousQuery]'
        }

        self.attribute_map = {
            'strategy': 'strategy',
            'collections': 'collections',
            'materialized_views': 'materialized_views',
            'continuous_queries': 'continuous_queries'
        }

        self._strategy = strategy
        self._collections = collections
        self._materialized_views = materialized_views
        self._continuous_queries = continuous_queries

    @property
    def strategy(self):
        """
        Gets the strategy of this Recipe.


        :return: The strategy of this Recipe.
        :rtype: str
        """
        return self._strategy

    @strategy.setter
    def strategy(self, strategy):
        """
        Sets the strategy of this Recipe.


        :param strategy: The strategy of this Recipe.
        :type: str
        """
        allowed_values = ["DEFAULT", "SPECIFIC"]
        if strategy not in allowed_values:
            raise ValueError(
                "Invalid value for `strategy` ({0}), must be one of {1}"
                .format(strategy, allowed_values)
            )

        self._strategy = strategy

    @property
    def collections(self):
        """
        Gets the collections of this Recipe.


        :return: The collections of this Recipe.
        :rtype: dict(str, CollectionDefinition)
        """
        return self._collections

    @collections.setter
    def collections(self, collections):
        """
        Sets the collections of this Recipe.


        :param collections: The collections of this Recipe.
        :type: dict(str, CollectionDefinition)
        """

        self._collections = collections

    @property
    def materialized_views(self):
        """
        Gets the materialized_views of this Recipe.


        :return: The materialized_views of this Recipe.
        :rtype: list[MaterializedView]
        """
        return self._materialized_views

    @materialized_views.setter
    def materialized_views(self, materialized_views):
        """
        Sets the materialized_views of this Recipe.


        :param materialized_views: The materialized_views of this Recipe.
        :type: list[MaterializedView]
        """

        self._materialized_views = materialized_views

    @property
    def continuous_queries(self):
        """
        Gets the continuous_queries of this Recipe.


        :return: The continuous_queries of this Recipe.
        :rtype: list[ContinuousQuery]
        """
        return self._continuous_queries

    @continuous_queries.setter
    def continuous_queries(self, continuous_queries):
        """
        Sets the continuous_queries of this Recipe.


        :param continuous_queries: The continuous_queries of this Recipe.
        :type: list[ContinuousQuery]
        """

        self._continuous_queries = continuous_queries

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
