# coding: utf-8

"""
    Rakam API Documentation

    An analytics platform API that lets you create your own analytics services.

    OpenAPI spec version: 0.5
    Contact: contact@rakam.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
"""

from pprint import pformat
from six import iteritems
import re


class UserSearchUsers(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, columns=None, filter=None, event_filters=None, sorting=None, offset=None, limit=None):
        """
        UserSearchUsers - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'columns': 'list[str]',
            'filter': 'str',
            'event_filters': 'list[EventFilter]',
            'sorting': 'Sorting',
            'offset': 'str',
            'limit': 'int'
        }

        self.attribute_map = {
            'columns': 'columns',
            'filter': 'filter',
            'event_filters': 'event_filters',
            'sorting': 'sorting',
            'offset': 'offset',
            'limit': 'limit'
        }

        self._columns = columns
        self._filter = filter
        self._event_filters = event_filters
        self._sorting = sorting
        self._offset = offset
        self._limit = limit

    @property
    def columns(self):
        """
        Gets the columns of this UserSearchUsers.


        :return: The columns of this UserSearchUsers.
        :rtype: list[str]
        """
        return self._columns

    @columns.setter
    def columns(self, columns):
        """
        Sets the columns of this UserSearchUsers.


        :param columns: The columns of this UserSearchUsers.
        :type: list[str]
        """

        self._columns = columns

    @property
    def filter(self):
        """
        Gets the filter of this UserSearchUsers.


        :return: The filter of this UserSearchUsers.
        :rtype: str
        """
        return self._filter

    @filter.setter
    def filter(self, filter):
        """
        Sets the filter of this UserSearchUsers.


        :param filter: The filter of this UserSearchUsers.
        :type: str
        """

        self._filter = filter

    @property
    def event_filters(self):
        """
        Gets the event_filters of this UserSearchUsers.


        :return: The event_filters of this UserSearchUsers.
        :rtype: list[EventFilter]
        """
        return self._event_filters

    @event_filters.setter
    def event_filters(self, event_filters):
        """
        Sets the event_filters of this UserSearchUsers.


        :param event_filters: The event_filters of this UserSearchUsers.
        :type: list[EventFilter]
        """

        self._event_filters = event_filters

    @property
    def sorting(self):
        """
        Gets the sorting of this UserSearchUsers.


        :return: The sorting of this UserSearchUsers.
        :rtype: Sorting
        """
        return self._sorting

    @sorting.setter
    def sorting(self, sorting):
        """
        Sets the sorting of this UserSearchUsers.


        :param sorting: The sorting of this UserSearchUsers.
        :type: Sorting
        """

        self._sorting = sorting

    @property
    def offset(self):
        """
        Gets the offset of this UserSearchUsers.


        :return: The offset of this UserSearchUsers.
        :rtype: str
        """
        return self._offset

    @offset.setter
    def offset(self, offset):
        """
        Sets the offset of this UserSearchUsers.


        :param offset: The offset of this UserSearchUsers.
        :type: str
        """

        self._offset = offset

    @property
    def limit(self):
        """
        Gets the limit of this UserSearchUsers.


        :return: The limit of this UserSearchUsers.
        :rtype: int
        """
        return self._limit

    @limit.setter
    def limit(self, limit):
        """
        Sets the limit of this UserSearchUsers.


        :param limit: The limit of this UserSearchUsers.
        :type: int
        """

        self._limit = limit

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
